#!/bin/bash
#set -e
#加载配置信息
function if_err(){
	if [ $? -ne 0 ];then
		exit 127
	fi
}

source ./install.ini
#定义安装程序的app路径
DEPLOY_FILE=$(dirname $0)/Health-cloud-server/app_server
#定义安装程序的db路径
DB_DEPLOY_FILE=$(dirname $0)/Health-cloud-server/db_server

if [ ! -d ${DEPLOY_DIR} ];then mkdir -p ${DEPLOY_DIR};fi
#定义部署目标路径(app,db)
app_sc_dir=${DEPLOY_DIR}/${APP_NAME}
db_sc_dir=${DB_DEPLOY_DIR}
#将docker-compose工程部署到本机
if [[ ! -d ${app_sc_dir} && ! -f  ~/.hcrc ]];then
         cp -rf ${DEPLOY_FILE}/${APP_NAME} ${app_sc_dir}
         cp -rf ${DB_DEPLOY_FILE} ${db_sc_dir}
	 if_err
else
        echo "目标目录已安装${APP_NAME},请检查${app_sc_dir} .hcrc是否存在"
        exit 127
fi

#将配置文件存入环境变量文件，使其全局生效(app和db目录各存一份)
cp ./install.ini ${app_sc_dir}/install.ini.example
cp ./install.ini ${db_sc_dir}/install.ini.example

env_context=$(cat ${app_sc_dir}/install.ini.example |grep -v "^#"|grep -v "^$")
echo "${env_context}">${app_sc_dir}/.env
echo "${env_context}">${db_sc_dir}/.env

source ${app_sc_dir}/.env
source ${db_sc_dir}/.env

ln -s ${app_sc_dir}/.env ${app_sc_dir}/install.ini 2>/dev/null
ln -s ${db_sc_dir}/.env ${db_sc_dir}/install.ini 2>/dev/null


#安装hcrc版本文件
echo -e "app_sc_dir=${app_sc_dir}\n db_sc_dir=${db_sc_dir}\n ${APP_NANME}版本${SC_IMAGE_VERSION}">~/.hcrc 2>/dev/null || echo ""

#安装hcctl管理命令
sudo cp hcctl /usr/local/bin && sudo chmod +x /usr/local/bin/hcctl
ln -s /usr/local/bin/hcctl /usr/bin/hcctl 2>/dev/null
cd ${app_sc_dir}

#--------------------部署-----------------------#
echo -e "----------安装向导------------"
echo -e "- all模式-->全部安装(主服务${APP_NAME}+数据库+队列)"
echo -e "- server模式-->只安装主服务${APP_NAME}(请注意提前修改install.ini中外部db和mq的连接配置)"
echo -e "- controller模式-->安装主服务${APP_NAME}+数据库 or 队列"
echo -e "------------------------------"
PS3='请选择安装模式: '

hcctl install_compose-files
if [ $? -ne 0 ];then
	echo "安装过程出现错误，请查看相关配置..."
	exit 127
fi
echo "${APP_NAME}服务已安装成功...."
sleep 2
echo -e "服务启动状态： "
sleep 2
sudo /usr/local/bin/hcctl status
sleep 2 
echo "Good Bye ~"
